//
//  AppDelegate.swift
//  Date
//
//  Created by Mark Meretzky on 10/17/18.
//  Copyright © 2018 New York University School of Professional Studies. All rights reserved.
//

import UIKit;

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?


    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        // Override point for customization after application launch.

        //Demonstrate that we can call a type method
        //even when no objects of the type currently exist.
        print("A year has \(Date.yearLength()) months.");

        //Call the init method that takes no parameters.
        let today: Date = Date();

        //Two ways to call the same method.  description is a computed property.
        print("Today is \(today.description).");
        print("Today is \(today).");

        print("Today is day number \(today.day) out of \(today.monthLength()) in month number \(today.month).");

        //Also calls the willSet and didSet property observers (if any) for the day property.
        today.day = 1;

        //Move the object one day forward.
        today.next();
        print("The second day of this month is \(today).");

        //Call the init method that takes three parameters.
        let independenceDay: Date = Date(month: 7, day: 4, year: 1776);
        print("Independence Day was \(independenceDay).");

        //Move the object one month forward.
        independenceDay.next(independenceDay.monthLength());
        print("America was one month old on \(independenceDay).");
        return true;
    }

    func applicationWillResignActive(_ application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
        // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(_ application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }


}

